import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _WeakMap from 'babel-runtime/core-js/weak-map';
import { cloneDeep } from 'lodash';

var privateModel = new _WeakMap();

var FieldModelPublic = function () {
  function FieldModelPublic(model) {
    _classCallCheck(this, FieldModelPublic);

    _initialiseProps.call(this);

    privateModel.set(this, model);
    this.name = cloneDeep(model.name);
  }

  _createClass(FieldModelPublic, [{
    key: 'value',
    get: function get() {
      var model = privateModel.get(this);
      return cloneDeep(model.value);
    }
  }, {
    key: 'focused',
    get: function get() {
      var model = privateModel.get(this);
      return cloneDeep(model.focused);
    }
  }, {
    key: 'touched',
    get: function get() {
      var model = privateModel.get(this);
      return cloneDeep(model.touched);
    }
  }, {
    key: 'dirty',
    get: function get() {
      var model = privateModel.get(this);
      return cloneDeep(model.dirty);
    }
  }]);

  return FieldModelPublic;
}();

var _initialiseProps = function _initialiseProps() {
  var _this = this;

  this.setValue = function (value) {
    var model = privateModel.get(_this);
    return model.setValue(value);
  };

  this.errors = function () {
    var model = privateModel.get(_this);
    return model.getErrors();
  };

  this.isValid = function () {
    var model = privateModel.get(_this);
    return model.isValid();
  };

  this.isExcluded = function () {
    var model = privateModel.get(_this);
    return model.isExcluded();
  };

  this.validate = function () {
    var model = privateModel.get(_this);
    return model.validate();
  };

  this.reload = function () {
    var model = privateModel.get(_this);
    return model.reload();
  };
};

export default FieldModelPublic;